diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/scheduler.h ns-3.31/src/core/model/scheduler.h
--- ns-3.30.1/src/core/model/scheduler.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/scheduler.h	2020-06-27 17:38:30.000000000 -0700
@@ -49,7 +49,96 @@
  * \ingroup scheduler
  * \brief Maintain the event list
  *
- * This base class specifies the interface used to maintain the
+ *
+ * In ns-3 the Scheduler manages the future event list.  There are several
+ * different Scheduler implementations with different time and space tradeoffs.
+ * Which one is "best" depends in part on the characteristics
+ * of the model being executed.  For optimized production work common
+ * practice is to benchmark each Scheduler on the model of interest.
+ * The utility program utils/bench-simulator.cc can do simple benchmarking
+ * of each SchedulerImpl against an exponential or user-provided
+ * event time distribution.
+ *
+ * The most important Scheduler functions for time performance are (usually)
+ * Scheduler::Insert (for new events) and Scheduler::RemoveNext (for pulling
+ * off the next event to execute).  Simulator::Cancel is usually
+ * implemented by simply setting a bit on the Event, but leaving it in the
+ * Scheduler; the Simulator just skips those events as they are encountered.
+ *
+ * For models which need a large event list the Scheduler overhead
+ * and per-event memory cost could also be important.  Some models
+ * rely heavily on Scheduler::Cancel, however, and these might benefit
+ * from using Scheduler::Remove instead, to reduce the size of the event
+ * list, at the time cost of actually removing events from the list.
+ *
+ * A summary of the main characteristics
+ * of each SchedulerImpl is provided below.  See the individual
+ * Scheduler pages for details on the complexity of the other API calls.
+ * (Memory overheads assume pointers and `std::size_t` are both 8 bytes.)
+ *
+ * <table class="markdownTable">
+ * <tr class="markdownTableHead">
+ *      <th class="markdownTableHeadCenter" colspan="2"> %Scheduler Type </th>
+ *      <th class="markdownTableHeadCenter" colspan="4">Complexity</th>
+ * </tr>
+ * <tr class="markdownTableHead">
+ *      <th class="markdownTableHeadLeft" rowspan="2"> %SchedulerImpl </th>
+ *      <th class="markdownTableHeadLeft" rowspan="2"> Method </th>
+ *      <th class="markdownTableHeadCenter" colspan="2"> %Time </th>
+ *      <th class="markdownTableHeadCenter" colspan="2"> Space</th>
+ * </tr>
+ * <tr class="markdownTableHead">
+ *      <th class="markdownTableHeadLeft"> %Insert()</th>
+ *      <th class="markdownTableHeadLeft"> %RemoveNext()</th>
+ *      <th class="markdownTableHeadLeft"> Overhead</th>
+ *      <th class="markdownTableHeadLeft"> Per %Event</th>
+ * </tr>
+ * <tr class="markdownTableBody">
+ *      <td class="markdownTableBodyLeft"> CalendarScheduler </td>
+ *      <td class="markdownTableBodyLeft"> `<std::list> []` </td>
+ *      <td class="markdownTableBodyLeft"> Constant </td>
+ *      <td class="markdownTableBodyLeft"> Constant </td>
+ *      <td class="markdownTableBodyLeft"> 24 bytes </td>
+ *      <td class="markdownTableBodyLeft"> 16 bytes </td>
+ * </tr>
+ * <tr class="markdownTableBody">
+ *      <td class="markdownTableBodyLeft"> HeapScheduler </td>
+ *      <td class="markdownTableBodyLeft"> Heap on `std::vector` </td>
+ *      <td class="markdownTableBodyLeft"> Logarithmic  </td>
+ *      <td class="markdownTableBodyLeft"> Logarithmic </td>
+ *      <td class="markdownTableBodyLeft"> 24 bytes </td>
+ *      <td class="markdownTableBodyLeft"> 0 </td>
+ * </tr>
+ * <tr class="markdownTableBody">
+ *      <td class="markdownTableBodyLeft"> ListScheduler </td>
+ *      <td class="markdownTableBodyLeft"> `std::list` </td>
+ *      <td class="markdownTableBodyLeft"> Linear </td>
+ *      <td class="markdownTableBodyLeft"> Constant </td>
+ *      <td class="markdownTableBodyLeft"> 24 bytes </td>
+ *      <td class="markdownTableBodyLeft"> 16 bytes </td>
+ * </tr>
+ * <tr class="markdownTableBody">
+ *      <td class="markdownTableBodyLeft"> MapScheduler </td>
+ *      <td class="markdownTableBodyLeft"> `std::map` </td>
+ *      <td class="markdownTableBodyLeft"> Logarithmic </td>
+ *      <td class="markdownTableBodyLeft"> Constant </td>
+ *      <td class="markdownTableBodyLeft"> 40 bytes </td>
+ *      <td class="markdownTableBodyLeft"> 32 bytes </td>
+ * </tr>
+ * <tr class="markdownTableBody">
+ *      <td class="markdownTableBodyLeft"> PriorityQueueScheduler </td>
+ *      <td class="markdownTableBodyLeft"> `std::priority_queue<,std::vector>` </td>
+ *      <td class="markdownTableBodyLeft"> Logarithmic  </td>
+ *      <td class="markdownTableBodyLeft"> Logarithmic </td>
+ *      <td class="markdownTableBodyLeft"> 24 bytes </td>
+ *      <td class="markdownTableBodyLeft"> 0 </td>
+ * </tr>
+ * </table>
+ *
+ * It is possible to change the Scheduler choice during a simulation,
+ * via Simulator::SetScheduler.
+ *
+ * The Scheduler base class specifies the interface used to maintain the
  * event list. If you want to provide a new event list scheduler,
  * you need to create a subclass of this base class and implement
  * all the pure virtual methods defined here.
@@ -139,6 +228,34 @@
 
 /**
  * \ingroup Events
+ * Compare (equal) two events by EventKey.
+ *
+ * \param [in] a The first event.
+ * \param [in] b The second event.
+ * \returns \c true if \c a != \c b
+ */
+inline bool operator == (const Scheduler::EventKey &a,
+                         const Scheduler::EventKey &b)
+{
+  return a.m_uid == b.m_uid;
+}
+
+/**
+ * \ingroup Events
+ * Compare (not equal) two events by EventKey.
+ *
+ * \param [in] a The first event.
+ * \param [in] b The second event.
+ * \returns \c true if \c a != \c b
+ */
+inline bool operator != (const Scheduler::EventKey &a,
+                         const Scheduler::EventKey &b)
+{
+  return a.m_uid != b.m_uid;
+}
+
+/**
+ * \ingroup Events
  * Compare (less than) two events by EventKey.
  *
  * Note the invariants which this function must provide:
@@ -169,20 +286,6 @@
 }
 
 /**
- * \ingroup Events
- * Compare (not equal) two events by EventKey.
- *
- * \param [in] a The first event.
- * \param [in] b The second event.
- * \returns \c true if \c a != \c b
- */
-inline bool operator != (const Scheduler::EventKey &a,
-                         const Scheduler::EventKey &b)
-{
-  return a.m_uid != b.m_uid;
-}
-
-/**
  * Compare (greater than) two events by EventKey.
  *
  * \param [in] a The first event.
@@ -208,6 +311,32 @@
 }
 
 /**
+ * Compare (equal) two events by Event.
+ *
+ * \param [in] a The first event.
+ * \param [in] b The second event.
+ * \returns \c true if \c a == \c b
+ */
+inline bool operator == (const Scheduler::Event &a,
+                         const Scheduler::Event &b)
+{
+  return a.key == b.key;
+}
+
+/**
+ * Compare (not equal) two events by Event.
+ *
+ * \param [in] a The first event.
+ * \param [in] b The second event.
+ * \returns \c true if \c a != \c b
+ */
+inline bool operator != (const Scheduler::Event &a,
+                         const Scheduler::Event &b)
+{
+  return a.key != b.key;
+}
+
+/**
  * Compare (less than) two events by Event.
  *
  * \param [in] a The first event.
@@ -220,6 +349,19 @@
   return a.key < b.key;
 }
 
+/**
+ * Compare (greater than) two events by Event.
+ *
+ * \param [in] a The first event.
+ * \param [in] b The second event.
+ * \returns \c true if \c a > \c b
+ */
+inline bool operator > (const Scheduler::Event &a,
+                        const Scheduler::Event &b)
+{
+  return a.key > b.key;
+}
+
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/show-progress.cc ns-3.31/src/core/model/show-progress.cc
--- ns-3.30.1/src/core/model/show-progress.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/show-progress.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,25 +25,31 @@
  * ns3::ShowProgress implementation.
  */
 
-#include <iomanip>
-
+#include "show-progress.h"
 #include "event-id.h"
 #include "log.h"
 #include "nstime.h"
 #include "simulator.h"
-#include "singleton.h"
 
-#include "show-progress.h"
+#include <iomanip>
+
 
 namespace ns3 {
 
-NS_LOG_COMPONENT_DEFINE ("ShowProgress");  
+NS_LOG_COMPONENT_DEFINE ("ShowProgress");
 
+/* static */
+const int64x64_t ShowProgress::HYSTERESIS = 1.414;
+/* static */
+const int64x64_t ShowProgress::MAXGAIN = 2.0;
+  
 ShowProgress::ShowProgress (const Time interval /* = Seconds (1.0) */,
                             std::ostream & os /* = std::cout */)
   : m_timer (),
+    m_stamp (),
+    m_elapsed (),
     m_interval (interval),
-    m_vtime (Seconds (1.0)),
+    m_vtime (Time (1)),
     m_event (),
     m_eventCount (0),
     m_printer (DefaultTimePrinter),
@@ -52,16 +58,29 @@
     m_repCount (0)
 {
   NS_LOG_FUNCTION (this << interval);
+  ScheduleCheckProgress ();
   Start ();
 }
 
+
+ShowProgress::~ShowProgress (void)
+{
+  Stop ();
+}
+
+
 void
 ShowProgress::SetInterval (const Time interval)
 {
   NS_LOG_FUNCTION (this << interval);
   const int64x64_t ratio = interval  / m_interval;
   m_interval = interval;
-  m_vtime = m_vtime * ratio;
+  // If we aren't at the initial value assume we have a reasonable
+  // update time m_vtime, so we should rescale it
+  if (m_vtime > Time (1))
+    {
+      m_vtime = m_vtime * ratio;
+    }
   Simulator::Cancel (m_event);
   Start ();
 
@@ -80,49 +99,85 @@
   NS_LOG_FUNCTION (this << verbose);
   m_verbose = verbose;
 }
-  
+
 void
 ShowProgress::SetStream (std::ostream & os)
 {
   m_os = &os;
 }
-  
+
 void
-ShowProgress::Start (void)
+ShowProgress::ScheduleCheckProgress (void)
 {
   NS_LOG_FUNCTION (this);
-  m_event = Simulator::Schedule (m_vtime, &ShowProgress::Feedback, this);
+  m_event = Simulator::Schedule (m_vtime, &ShowProgress::CheckProgress, this);
   m_timer.Start ();
-  
-}  // ShowProgress::Start
+
+}  // ShowProgress::ScheduleCheckProgress
+
+void
+ShowProgress::GiveFeedback (uint64_t nEvents, int64x64_t ratio, int64x64_t speed)
+{
+  // Save stream state
+  auto precision = m_os->precision ();
+  auto flags = m_os->flags ();
+
+  m_os->setf (std::ios::fixed, std:: ios::floatfield);
+
+  if (m_verbose)
+    {
+      (*m_os) << std::right << std::setw (5) << m_repCount << std::left
+              << (ratio > (1.0 / HYSTERESIS) ? "-->" : "   ")
+              << std::setprecision (9) 
+              << " [del: " << m_elapsed.As (Time::S)
+              << "/ int: " << m_interval.As (Time::S)
+              << " = rat: " << ratio
+              << (ratio > HYSTERESIS ? " dn" :
+          (ratio < 1.0 / HYSTERESIS ? " up" : " --"))
+              << ", vt: " << m_vtime.As (Time::S) << "] ";
+    }
+
+  // Print the current time
+  (*m_printer)(*m_os);
+
+  (*m_os) << " ("
+          << std::setprecision (3) << std::setw (8) << speed.GetDouble () << "x real time) "
+          << nEvents << " events processed"
+          << std::endl
+          << std::flush;
+
+  // Restore stream state
+  m_os->precision (precision);
+  m_os->flags (flags);
+
+}  // ShowProgress::GiveFeedback
 
 void
-ShowProgress::Feedback (void)
+ShowProgress::CheckProgress (void)
 {
   // Get elapsed wall clock time
-  Time elapsed = MilliSeconds (m_timer.End ());
-  NS_LOG_FUNCTION (this << elapsed);
+  m_elapsed += MilliSeconds (m_timer.End ());
+  NS_LOG_FUNCTION (this << m_elapsed);
 
   // Don't do anything unless the elapsed time is positive.
-  if (elapsed <= Time (0))
+  if (m_elapsed <= Time (0))
     {
       m_vtime = m_vtime * MAXGAIN;
-      Start ();
+      ++m_repCount;
+      ScheduleCheckProgress ();
       return;
     }
 
   // Speed: how fast are we compared to real time
-  const int64x64_t speed = m_vtime / elapsed;
-  
+  const int64x64_t speed = m_vtime / m_elapsed;
+
   // Ratio: how much real time did we use,
   // compared to reporting interval target
-  const int64x64_t ratio = elapsed / m_interval;
+  const int64x64_t ratio = m_elapsed / m_interval;
 
   // Elapsed event count
   uint64_t events = Simulator::GetEventCount ();
   uint64_t nEvents = events - m_eventCount;
-  m_eventCount = events;
-  
   /**
    * \internal Update algorithm
    *
@@ -141,82 +196,101 @@
    * updates to \c m_vtime are sketched in this figure:
    * \verbatim
                       ^
-                      |   
+                      |
               ratio   |   vtime update
                       |
-                      |   
-                      |   *= MAXGAIN
-                      |   
-            MAXGAIN  -|--------------    *= min (ratio, MAXGAIN)
-                      |   
-                      |   *= ratio
-                      |   
+                      |
+                      |   /= MAXGAIN
+                      |
+            MAXGAIN  -|--------------    /= min (ratio, MAXGAIN)
+                      |
+                      |   /= ratio
+                      |
          HYSTERESIS  -|=============================================
-                      |   
-                      |   
-                      |   
+                      |
+                      |
+                      |
                    1 -|   No change
-                      |   
-                      |   
+                      |
+                      |
                       |
       1/ HYSTERESIS  -|==============================================
-                      |   
-                      |   *= ratio
-                      |   
-         1/ MAXGAIN  -|---------------   *=  max (ratio, 1/ MAXGAIN)   
-                      |   
-                      |   *= 1/MAXGAIN
-                      |   
+                      |
+                      |   *= 1 / ratio
+                      |
+         1/ MAXGAIN  -|---------------   *=  min (1 / ratio, MAXGAIN)
+                      |
+                      |   *= MAXGAIN
+                      |
      \endverbatim
    *
    * As indicated, when ratio is outside the hysteresis band
    * it amounts to multiplying \c m_vtime by the min/max of the ratio
    * with the appropriate MAXGAIN factor.
+   *
+   * Finally, some experimentation suggests we further dampen
+   * movement between HYSTERESIS and MAXGAIN, so we only apply
+   * half the ratio.  This reduces "hunting" for a stable update
+   * period.
+   *
+   * \todo Evaluate if simple exponential averaging would be
+   * more effective, simpler.
    */
   if (ratio > HYSTERESIS)
     {
-      m_vtime = m_vtime / std::min (ratio, MAXGAIN);
+      int64x64_t f = 1 + (ratio - 1) / 2;
+      if (ratio > MAXGAIN)
+        {
+          f = MAXGAIN;
+        }
+
+      m_vtime = m_vtime / f;
     }
   else if (ratio < 1.0 / HYSTERESIS)
     {
-      m_vtime = m_vtime / std::max (ratio, 1.0 / MAXGAIN);
+      int64x64_t f = 1 + (1 / ratio - 1)/2;
+      if (1 / ratio > MAXGAIN)
+        {
+          f = MAXGAIN;
+        }
+      m_vtime = m_vtime * f;
     }
 
-  // Save stream state
-  auto precision = m_os->precision ();
-  auto flags = m_os->flags ();
-  
-  m_os->setf (std::ios::fixed, std:: ios::floatfield);
-
-  if (m_verbose)
+  // Only give feedback if ratio is at least as big as 1/HYSTERESIS
+  if (ratio > (1.0 / HYSTERESIS))
     {
-      (*m_os) << m_repCount
-              << " [del: " << elapsed.As(Time::S)
-              << "/ int: " << m_interval.As(Time::S)
-              << " = rat: " << ratio 
-              << (ratio > HYSTERESIS ? " up" :
-                  (ratio < 1.0 / HYSTERESIS ? " dn" : " --"))
-              << ", vt: " << m_vtime.As(Time::S) << "] ";
+      GiveFeedback (nEvents, ratio, speed);
+      m_elapsed = Time (0);
+      m_eventCount = events;
     }
-  m_repCount++;
-  
-  // Print the current time
-  (*m_printer)(*m_os);
+  else
+    {
+      NS_LOG_LOGIC ("skipping update: " << ratio);
+      // enable this line for debugging, with --verbose
+      // GiveFeedback (nEvents, ratio, speed);
+    }
+  ++m_repCount;
   
-  (*m_os) << " ("
-          << std::setprecision (3) << std::setw (8) << speed.GetDouble () << "x real time) "
-          << nEvents << " events processed"
-          << std::endl
-          << std::flush;
+  // And do it again
+  ScheduleCheckProgress ();
 
-  // Restore stream state
-  m_os->precision (precision);
-  m_os->flags (flags);
+}  // ShowProgress::CheckProgress
 
-  // And do it again
-  Start ();
+void
+ShowProgress::Start (void)
+{
+  m_stamp.Stamp ();
+  (*m_os) << "Start wall clock: " << m_stamp.ToString ()
+          << std::endl;
+}  // ShowProgress::Start
 
-}  // ShowProgress::Feedback
+void
+ShowProgress::Stop (void)
+{
+  m_stamp.Stamp ();
+  (*m_os) << "End wall clock:  " << m_stamp.ToString ()
+          << "\nElapsed wall clock: " << m_stamp.GetInterval () << "s"
+          << std::endl;
+}  // ShowProgress::Stop
 
-  
 }  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/show-progress.h ns-3.31/src/core/model/show-progress.h
--- ns-3.30.1/src/core/model/show-progress.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/show-progress.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,8 +31,11 @@
 
 #include <iostream>
 
+#include "event-id.h"
 #include "nstime.h"
 #include "system-wall-clock-ms.h"
+#include "system-wall-clock-timestamp.h"
+#include "time-printer.h"
 
 namespace ns3 {
 
@@ -61,7 +64,22 @@
  *       Simulator::Destroy ();
  *     }
  * \endcode
- * 
+ *
+ * This generates output similar to the following:
+ *
+ * \code
+ *     Start wall clock: Tue May 19 10:24:07 2020
+ *     +17.179869183s (   4.937x real time) 29559 events processed
+ *     +25.769803775s (   4.965x real time) 45179 events processed
+ *     +51.539607551s (   8.810x real time) 49421 events processed
+ *     +90.324463739s (   7.607x real time) 58021 events processed
+ *     +129.770882188s (   7.576x real time) 53850 events processed
+ *     +170.958751090s (   8.321x real time) 56473 events processed
+ *     +194.339562435s (  12.776x real time) 30957 events processed
+ *     End wall clock:  Tue May 19 10:24:23 2020
+ *     Elapsed wall clock: 16s
+ * \endcode
+ *
  * Based on a python version by Gustavo Carneiro <gjcarneiro@gmail.com>,
  * as released here:
  * http://mailman.isi.edu/pipermail/ns-developers/2009-January/005201.html
@@ -75,7 +93,10 @@
    * \param [in] os The stream to print on.
    */
   ShowProgress (const Time interval = Seconds (1.0),
-		std::ostream & os = std::cout);
+                std::ostream & os = std::cout);
+
+  /** Destructor. */
+  ~ShowProgress (void);
 
   /**
    * Set the target update interval, in wallclock time.
@@ -98,9 +119,6 @@
    * \param [in] os The output stream; defaults to std::cerr.
    */
   void SetStream (std::ostream & os);
-  
-  /** Start the progress timer. */
-  void Start (void);
 
   /**
    * Set verbose mode to print real and virtual time intervals.
@@ -109,23 +127,53 @@
    */
   void SetVerbose (bool verbose);
 
-   
 private:
-  /** Show execution progress. */
-  void Feedback (void);
+  
+  /**
+   * Start the elapsed wallclock timestamp and print the start time.
+   * This is triggered by the constructor.
+   */
+  void Start (void);
+
+  /**
+   * Stop the elapsed wallclock timestamp and print the total elapsed time.
+   * This is triggered by the destructor.
+   */
+  void Stop (void);
+
+  /**
+   * Schedule the next CheckProgress.
+   */
+  void ScheduleCheckProgress (void);
+
+  /**
+   * Check on execution progress.
+   * This function is executed periodically, updates the internal
+   * state on rate of progress, and decides if it's time to generate
+   * output.
+   */
+  void CheckProgress (void);
+
+  /**
+   * Show execution progress.
+   * This function actually generates output, when directed by CheckProgress().
+   */
+  void GiveFeedback (uint64_t nEvents, int64x64_t ratio, int64x64_t speed);
 
   /**
    * Hysteresis factor.
    * \see Feedback()
    */
-  const int64x64_t HYSTERESIS = 1.2;
+  static const int64x64_t HYSTERESIS;
   /**
    * Maximum growth factor.
    * \see Feedback()
    */
-  const int64x64_t MAXGAIN = 2.0;
-  
+  static const int64x64_t MAXGAIN;
+
   SystemWallClockMs m_timer;  //!< Wallclock timer
+  SystemWallClockTimestamp m_stamp;  //!< Elapsed wallclock time.
+  Time m_elapsed;             //!< Total elapsed wallclock time since last update.
   Time m_interval;            //!< The target update interval, in wallclock time
   Time m_vtime;               //!< The virtual time interval.
   EventId m_event;            //!< The next progress event.
@@ -134,10 +182,10 @@
   TimePrinter m_printer;      //!< The TimePrinter to use
   std::ostream *m_os;         //!< The output stream to use.
   bool m_verbose;             //!< Verbose mode flag
-  uint64_t m_repCount;        //!< Count of progress lines printed
-  
+  uint64_t m_repCount;        //!< Number of CheckProgress events
+
 };  // class ShowProgress
-  
+
 }  // namespace ns3
 
 #endif  /* SHOW_PROGRESS_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/simple-ref-count.h ns-3.31/src/core/model/simple-ref-count.h
--- ns-3.30.1/src/core/model/simple-ref-count.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/simple-ref-count.h	2020-06-27 17:38:30.000000000 -0700
@@ -44,7 +44,7 @@
  * This template can be used to give reference-counting powers
  * to a class. This template does not require this class to
  * have a virtual destructor or a specific (or any) parent class.
- * 
+ *
  * \note If you are moving to this template from the RefCountBase class,
  * you need to be careful to mark appropriately your destructor virtual
  * if needed. i.e., if your class has subclasses, _do_ mark your destructor
@@ -89,7 +89,7 @@
   /**
    * Assignment operator
    * \param [in] o The object to copy
-   * \returns The copy of \p o
+   * \returns The copy of \pname{o}
    */
   SimpleRefCount &operator = (const SimpleRefCount &o)
   {
@@ -104,12 +104,12 @@
    */
   inline void Ref (void) const
   {
-    NS_ASSERT (m_count < std::numeric_limits<uint32_t>::max());
+    NS_ASSERT (m_count < std::numeric_limits<uint32_t>::max ());
     m_count++;
   }
   /**
    * Decrement the reference count. This method should not be called
-   * by user code. SimpleRefCount instances are expected to be used in 
+   * by user code. SimpleRefCount instances are expected to be used in
    * conjunction with the Ptr template which would make calling Ref
    * unnecessary and dangerous.
    */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/simulator.cc ns-3.31/src/core/model/simulator.cc
--- ns-3.30.1/src/core/model/simulator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/simulator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -55,18 +55,20 @@
 
 /**
  * \ingroup simulator
+ * \anchor GlobalValueSimulatorImplementationType
  * The specific simulator implementation to use.
  *
  * Must be derived from SimulatorImpl.
  */
 static GlobalValue g_simTypeImpl = GlobalValue
-  ("SimulatorImplementationType",
-   "The object class to use as the simulator implementation",
-   StringValue ("ns3::DefaultSimulatorImpl"),
-   MakeStringChecker ());
+    ("SimulatorImplementationType",
+    "The object class to use as the simulator implementation",
+    StringValue ("ns3::DefaultSimulatorImpl"),
+    MakeStringChecker ());
 
 /**
  * \ingroup scheduler
+ * \anchor GlobalValueSchedulerType
  * The specific event scheduler implementation to use.
  *
  * Must be derived from Scheduler.
@@ -81,7 +83,7 @@
  * \brief Get the static SimulatorImpl instance.
  * \return The SimulatorImpl instance pointer.
  */
-static SimulatorImpl **PeekImpl (void)
+static SimulatorImpl ** PeekImpl (void)
 {
   static SimulatorImpl *impl = 0;
   return &impl;
@@ -119,9 +121,9 @@
 
 //
 // Note: we call LogSetTimePrinter _after_ creating the implementation
-// object because the act of creation can trigger calls to the logging 
-// framework which would call the TimePrinter function which would call 
-// Simulator::Now which would call Simulator::GetImpl, and, thus, get us 
+// object because the act of creation can trigger calls to the logging
+// framework which would call the TimePrinter function which would call
+// Simulator::Now which would call Simulator::GetImpl, and, thus, get us
 // in an infinite recursion until the stack explodes.
 //
       LogSetTimePrinter (&DefaultTimePrinter);
@@ -135,13 +137,13 @@
 {
   NS_LOG_FUNCTION_NOARGS ();
 
-  SimulatorImpl **pimpl = PeekImpl (); 
+  SimulatorImpl **pimpl = PeekImpl ();
   if (*pimpl == 0)
     {
       return;
     }
   /* Note: we have to call LogSetTimePrinter (0) below because if we do not do
-   * this, and restart a simulation after this call to Destroy, (which is 
+   * this, and restart a simulation after this call to Destroy, (which is
    * legal), Simulator::GetImpl will trigger again an infinite recursion until
    * the stack explodes.
    */
@@ -159,14 +161,14 @@
   GetImpl ()->SetScheduler (schedulerFactory);
 }
 
-bool 
+bool
 Simulator::IsFinished (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
   return GetImpl ()->IsFinished ();
 }
 
-void 
+void
 Simulator::Run (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
@@ -174,7 +176,7 @@
   GetImpl ()->Run ();
 }
 
-void 
+void
 Simulator::Stop (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
@@ -182,7 +184,7 @@
   GetImpl ()->Stop ();
 }
 
-void 
+void
 Simulator::Stop (Time const &delay)
 {
   NS_LOG_FUNCTION (delay);
@@ -229,7 +231,7 @@
 {
   return DoScheduleDestroy (GetPointer (ev));
 }
-EventId 
+EventId
 Simulator::DoSchedule (Time const &time, EventImpl *impl)
 {
 #ifdef ENABLE_DES_METRICS
@@ -237,7 +239,7 @@
 #endif
   return GetImpl ()->Schedule (time, impl);
 }
-EventId 
+EventId
 Simulator::DoScheduleNow (EventImpl *impl)
 {
 #ifdef ENABLE_DES_METRICS
@@ -245,37 +247,13 @@
 #endif
   return GetImpl ()->ScheduleNow (impl);
 }
-EventId 
+EventId
 Simulator::DoScheduleDestroy (EventImpl *impl)
 {
   return GetImpl ()->ScheduleDestroy (impl);
 }
 
 
-EventId
-Simulator::Schedule (Time const &delay, void (*f)(void))
-{
-  return DoSchedule (delay, MakeEvent (f));
-}
-
-void
-Simulator::ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(void))
-{
-  return ScheduleWithContext (context, delay, MakeEvent (f));
-}
-
-EventId
-Simulator::ScheduleNow (void (*f)(void))
-{
-  return DoScheduleNow (MakeEvent (f));
-}
-
-EventId
-Simulator::ScheduleDestroy (void (*f)(void))
-{
-  return DoScheduleDestroy (MakeEvent (f));
-}
-
 void
 Simulator::Remove (const EventId &id)
 {
@@ -296,7 +274,7 @@
   return GetImpl ()->Cancel (id);
 }
 
-bool 
+bool
 Simulator::IsExpired (const EventId &id)
 {
   if (*PeekImpl () == 0)
@@ -311,7 +289,7 @@
   return Time (Simulator::Now ());
 }
 
-Time 
+Time
 Simulator::GetMaximumSimulationTime (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
@@ -323,11 +301,11 @@
 {
   return GetImpl ()->GetContext ();
 }
-  
+
 uint64_t
 Simulator::GetEventCount (void)
 {
-  return GetImpl ()-> GetEventCount ();
+  return GetImpl ()->GetEventCount ();
 }
 
 uint32_t
@@ -362,9 +340,9 @@
   impl->SetScheduler (factory);
 //
 // Note: we call LogSetTimePrinter _after_ creating the implementation
-// object because the act of creation can trigger calls to the logging 
-// framework which would call the TimePrinter function which would call 
-// Simulator::Now which would call Simulator::GetImpl, and, thus, get us 
+// object because the act of creation can trigger calls to the logging
+// framework which would call the TimePrinter function which would call
+// Simulator::Now which would call Simulator::GetImpl, and, thus, get us
 // in an infinite recursion until the stack explodes.
 //
   LogSetTimePrinter (&DefaultTimePrinter);
